int turn = 1;


active proctype P() { // Simple process
    do // Do this forever or until we encounter break
    ::  printf("Noncritical section P\n"); /* We will create a non-det. loop here
															that might or might not end */
		do  :: true -> skip; // do nothing and run the loop again
		    :: break; // exit loop
		od;
		
        Pwaiting: turn == 1;
        csp: printf("CRITICAL P\n"); // We enter the CS
        
        turn = 2; // We signal that we are done with the CS
    od
}

active proctype Q() { // The mirrored process
    do
    ::  printf("Noncritical section Q\n");

       Qwaiting: turn == 2; 
        csq: printf("CRITICAL Q\n"); // We enter the CS
        
        turn = 1; // We signal that we are done with the CS
    od
}

ltl mutex {[] ! (P@csp && Q@csq)}
ltl nomutex {<> (P@csp && Q@csq)}
ltl nodead {[] !(P@Pwaiting && (turn == 2) && Q@Qwaiting && (turn == 1))}
ltl dead   {<>(P@Pwaiting && (turn == 2) && Q@Qwaiting && (turn == 1))}
ltl livep {[](P@Pwaiting -> <> P@csp)}
ltl liveq {[]((Q@Qwaiting) -> (<> (Q@csq)))}
